jenkins:
  systemMessage: "Jenkins configured automatically by Jenkins Configuration as Code (JCasC)"

credentials:
  system:
    domainCredentials:
      - credentials:
          - string:
              scope: GLOBAL
              id: "gitlab-creds"
              description: "GitLab Access Token for Jenkins"
              secret: "{{ gitlab_api_pat }}"

          - string:
              scope: GLOBAL
              id: "tfe-token"
              description: "Terraform Cloud Access Token for Jenkins"
              secret: "{{ tfe_token }}"

          - string:
              scope: GLOBAL
              id: "aws-access-key-id"
              description: "AWS Access Key Id for Jenkins"
              secret: "{{ aws_access_key_id }}"
          
          - string:
              scope: GLOBAL
              id: "aws-secret-access-key"
              description: "AWS Secret Access Key for Jenkins"
              secret: "{{ aws_secret_access_key }}"

          - basicSSHUserPrivateKey:
              scope: GLOBAL
              id: "vm-ssh-creds"
              description: "SSH Credentials for VM"
              username: "root"
              privateKeySource:
                directEntry:
                  privateKey: |
                    {{ ssh_private_key | indent(20) }}

jobs:
  - script: >
      pipelineJob('provision-aws-ecr') {
        parameters {
          booleanParam('DESTROY', false, 'Set to true to destroy resources, false to provision')
        }
        definition {
          cpsScm {
            scm {
              git {
                remote {
                  url('https://gitlab.com/devops4075122/jenkins-pipelines/jenkins-pipelines.git')
                  credentials('gitlab-creds')
                }
                branches('*/main')
              }
            }
            scriptPath('provision-aws-ecr/Jenkinsfile')
          }
        }
      }
  - script: >
      pipelineJob('provision-aws-eks') {
        parameters {
          booleanParam('DESTROY', false, 'Set to true to destroy resources, false to provision')
        }
        definition {
          cpsScm {
            scm {
              git {
                remote {
                  url('https://gitlab.com/devops4075122/jenkins-pipelines/jenkins-pipelines.git')
                  credentials('gitlab-creds')
                }
                branches('*/main')
              }
            }
            scriptPath('provision-aws-eks/Jenkinsfile')
          }
        }
      }
  - script: >
      pipelineJob('provision-aws-eks-ec2') {
        parameters {
          booleanParam('DESTROY', false, 'Set to true to destroy resources, false to provision')
        }
        definition {
          cpsScm {
            scm {
              git {
                remote {
                  url('https://gitlab.com/devops4075122/jenkins-pipelines/jenkins-pipelines.git')
                  credentials('gitlab-creds')
                }
                branches('*/main')
              }
            }
            scriptPath('provision-aws-eks-ec2/Jenkinsfile')
          }
        }
      }
  - script: >
      pipelineJob('build-and-deploy-microservices') {
        parameters {
          booleanParam('SKIP_BUILD', false, 'Skip building and pushing Docker images')
          choiceParam('CLUSTER_TYPE', ['eks-serverless', 'eks-ec2'], 'Choose which EKS cluster to use')
        }
        definition {
          cpsScm {
            scm {
              git {
                remote {
                  url('https://gitlab.com/devops4075122/jenkins-pipelines/jenkins-pipelines.git')
                  credentials('gitlab-creds')
                }
                branches('main')
              }
            }
            scriptPath('build-and-deploy-microservices/Jenkinsfile')
          }
        }
      }